> ## Documentation Index
> Fetch the complete documentation index at: https://docs.yapily.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Confirm Funds for VRP Payment

> Check whether the requested funds amount is available on the [VRP](/payments/vrps/introduction) consent.

Note that you should not call this before each VRP payment submission because we do it for you.

Required feature: `VARIABLE_RECURRING_PAYMENT_FUNDS_CONFIRMATION`

<Info>Learn more: [Confirm Availability of Funds](/payments/vrps/get-started#confirm-availability-of-funds)</Info>


## OpenAPI

````yaml /openapi-converted.json post /variable-recurring-payments/funds-confirmation
openapi: 3.0.1
info:
  description: >-
    The Yapily API enables connections between your application and users'
    banks. For more information check out our [documentation](/introduction).


    In particular, make sure to view our [Getting
    Started](/getting-started/get-started) steps if this is your first time
    here.


    While testing the API, our list of [sandbox
    credentials](/resources/sandbox/sandbox-credentials) maybe useful.
  title: Yapily API
  version: 12.3.4
  contact:
    name: Yapily Support
    url: https://docs.yapily.com/resources/support
    email: support@yapily.com
servers:
  - url: https://api.yapily.com
security:
  - basicAuth: []
tags:
  - description: >-
      The `Application` is the base entity that is used to interact with the API
      and contains a collection of `Institution` objects. You can have multiple
      Applications associated with your account e.g. a production application
      with live access to each `Institution` and a development application with
      access to sandboxes.
    name: Application
  - description: >-
      The Users endpoints are used to manage each user (otherwise known as the
      PSU) in Yapily. Each user belongs to an Application and as a consequence,
      so do each `Consent` created for a particular `User`.
    name: Users
  - description: >-
      An `Institution` object represents any Account Serving Payment Servicing
      Provider (ASPSP) that has been integrated and is accessible through the
      Yapily APIs (ASPSPs are entities that publish Read/Write APIs to permit,
      with customer consent, payments initiated by third party providers and/or
      make their customers financial data available to third party providers via
      their API endpoints).


      Any one of the following would be represented as Institution:


      - Traditional banks e.g. Santander

      - Neo-banks e.g. Monzo

      - Building societies e.g. Cumberland Building Society
    name: Institutions
  - description: >-
      The Consents endpoints are used to manage each `Consent` created by Yapily
      in response to an authorisation created for a user.


      The `Consent` object contains data that identifies a user's consent for a
      specific `Institution` within a Yapily application. Other than the id of
      the consent, the `institution-id` for the corresponding `Institution` and
      the user identifiers (`user-uuid` and `application-user-id`), it contains
      various details that indicates how the `Consent` can be used.
    name: Consents
  - description: >-
      Before calling [Financial Data](#yapily-api-financial-data) or
      [Payments](#yapily-api-payments) endpoints, a consent from an end-user
      must be obtained.


      Consents are valid for up to 90 days for Financial Data endpoints and have
      a single-use for Payment endpoints i.e. a new consent must be obtained for
      each payment.


      NOTE: A user consent is also referred to as an 'Authorisation'.
    name: Authorisations
  - description: >-
      In order to access a user's Financial Data, you are required to request an
      [Authorisation](#tag/Authorisations) from the user to share the account
      information the bank has. Once a `consent-token` is obtained, you can call
      the necessary Financial Data endpoint(s) to retrieve the user's data.
    name: Financial Data
  - description: >-
      In order to make a Payment on behalf of a user, you are required to
      request an [Authorisation](#tag/Authorisations) from the user to authorise
      the user's account to make the payment from. Once a `consent-token` is
      obtained, you can call the necessary Payments endpoint(s) to execute a
      payment.
    name: Payments
  - description: >+
      The Notifications endpoints provide an interactive way for user to receive
      notifications according to different event-types. This feature is
      currently in private beta. Please reach out if you require access. 

    name: Notifications
  - description: >-
      Variable Recurring Payments enables transfer of money between accounts
      held by the same person or transfer of money for business payments. 


      In order to make Sweeping Variable Recurring Payments on behalf of a user,
      you are required to request an [Consent](#tag/Authorisations) from the
      user by calling the Sweeping Consent endpoint to authorise the user's
      account to make the payment. Once a `consent-token` is obtained, you can
      call the Payments endpoint to execute the Sweeping Variable Recurring
      Payments transaction. Before executing the payment, you have the option to
      confirm availability of funds in the user's account by calling the Funds
      Confirmation endpoint. 


      See [VRP Payments](/payments/vrps/additional-information) for more
      information.
    name: Variable Recurring Payments
  - description: Hosted Payment Pages endpoints for payments products
    name: Hosted Payment Pages
  - description: Hosted Consent Pages endpoints for data products
    name: Hosted Consent Pages
  - description: >-
      The constraints endpoints can be used to retrieve institution specific
      data requirements and rules that will apply when performing other
      operations.
    name: Constraints
  - description: >-
      Application Management endpoints help with creating and managing client
      sub-applications.
    name: Application Management
  - description: 'Data Plus endpoints enable our customers to enrich transaction data. '
    name: Data Plus
  - description: Webhook endpoints
    name: Webhooks
  - description: Application Beneficiaries Endpoints
    name: Application Beneficiaries
  - description: User Beneficiaries Endpoints
    name: User Beneficiaries
paths:
  /variable-recurring-payments/funds-confirmation:
    post:
      tags:
        - Variable Recurring Payments
      summary: Confirm Funds for VRP Payment
      description: >-
        Check whether the requested funds amount is available on the
        [VRP](/payments/vrps/introduction) consent.


        Note that you should not call this before each VRP payment submission
        because we do it for you.


        Required feature: `VARIABLE_RECURRING_PAYMENT_FUNDS_CONFIRMATION`
      operationId: createVrpFundsConfirmation
      parameters:
        - description: >-
            The user's VRP [Consent
            Token](/getting-started/glossary#consent-token)
          example: '{consentToken}'
          in: header
          name: consent
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json;charset=UTF-8:
            examples:
              UK VRP Funds Confirmation Request:
                description: UK VRP Funds Confirmation Request
                value:
                  reference: Own Account Sweeping
                  paymentAmount:
                    amount: 10
                    currency: GBP
            schema:
              $ref: '#/components/schemas/VrpFundsConfirmationRequest'
        required: true
      responses:
        '201':
          description: Created
          content:
            application/json;charset=UTF-8:
              examples:
                UK VRP Funds Confirmation Response:
                  description: UK VRP Funds Confirmation Response
                  value:
                    meta:
                      tracingId: 0f14e900011b445fa6b6c2c4272d7321
                    data:
                      id: a9582f8e-08be-4cca-9f01-1ad3be96532d
                      fundsAvailable:
                        fundsAvailable: true
                        fundsAvailableAt: '2021-06-08T10:59:35.138Z'
                      reference: Own Account Sweeping
                      paymentAmount:
                        amount: 10
                        currency: GBP
              schema:
                $ref: '#/components/schemas/ApiResponseOfVrpFundsConfirmationResponse'
        '401':
          content:
            application/json;charset=UTF-8:
              examples:
                Error Response:
                  description: Error Response
                  value:
                    error:
                      tracingId: 0c2d0973bdd24224a65e5d0f7d1b6154
                      code: 401
                      status: UNAUTHORIZED
                      supportUrl: https://support.yapily.com/
                      source: YAPILY
                      issues:
                        - type: CREDENTIALS
                          code: CREDENTIALS_MISSING
                          message: Authentication header not present
              schema:
                $ref: '#/components/schemas/ApiErrorResponse'
          description: Error Response
        default:
          content:
            application/json;charset=UTF-8:
              examples:
                Error Response:
                  description: Error Response
                  value:
                    error:
                      tracingId: 0c2d0973bdd24224a65e5d0f7d1b6154
                      code: 400
                      status: BAD_REQUEST
                      supportUrl: https://support.yapily.com/
                      source: YAPILY
                      issues:
                        - type: BAD_REQUEST
                          code: BAD_REQUEST
                          message: >-
                            The server could not understand the request due to
                            invalid syntax
              schema:
                $ref: '#/components/schemas/ApiErrorResponse'
          description: Error Response
components:
  schemas:
    VrpFundsConfirmationRequest:
      type: object
      required:
        - paymentAmount
      properties:
        paymentAmount:
          $ref: '#/components/schemas/Amount'
        reference:
          type: string
          description: >-
            __Optional__. The reference/description associated with the VRP
            consent. Limited to a maximum of 18 characters long.
    ApiResponseOfVrpFundsConfirmationResponse:
      type: object
      properties:
        meta:
          $ref: '#/components/schemas/ResponseMeta'
        data:
          $ref: '#/components/schemas/VrpFundsConfirmationResponse'
        links:
          type: object
          additionalProperties:
            type: string
        forwardedData:
          type: array
          items:
            $ref: '#/components/schemas/ResponseForwardedData'
        tracingId:
          type: string
          writeOnly: true
        raw:
          deprecated: true
          type: array
          items:
            $ref: '#/components/schemas/RawResponse'
    ApiErrorResponse:
      type: object
      properties:
        error:
          $ref: '#/components/schemas/ErrorDetails'
      description: >-
        Used to return errors from the bank from each request


        - `400` - Returned by any `POST` endpoint when the body does not conform
        to the contract

        - `401` - Returned by any endpoint when an invalid `authToken` is used
        for authentication

        - `403` - Returned by any [Financial Data](/api-reference/...) and any
        [Payments](/api-reference/...) endpoint when the `Consent` is no longer
        authorised to access financial data or to make a payment

        - `404` - Returned by any endpoint where there are path parameters and
        the path parameters supplied are unable to find the desired resource

        - `409` - Returned by any `POST` endpoint when creating a resource that
        conflicts with any other existing resource e.g. [Create
        User](/api-reference/...)

        - `424` - Returned by any [Financial Data](/api-reference/...) and any
        [Payments](/api-reference/...) endpoint when the feature to be accessed
        is not supported by the `Institution`.

        - `500` - Returned by any endpoint when Yapily is down. If you encounter
        any false positives, please [notify us](mailto:support@yapily.com)
      example:
        error:
          tracingId: 0c2d0973bdd24224a65e5d0f7d1b6154
          code: 400
          status: BAD_REQUEST
          supportUrl: https://support.yapily.com/
          source: YAPILY
          issues:
            - type: INVALID_REQUEST
              code: INVALID_PROPERTY_UNEXPECTED_VALUE
              parameter: $.payer.accountidentifications.type
              message: Type Should be one of [PAN, SORT_CODE, ACCOUNT_NUMBER]
              institutionError:
                errorMessage: >-
                  {"Code":"400
                  BadRequest","Id":"3517bfc2-c3ee-4f2f-b4f8-12f62478e0d1","Message":"No
                  Resource
                  found","Errors":[{"ErrorCode":"UK.OBIE.Resource.NotFound","Message":"No
                  resource found corresponding to the consent id"}]}
                httpStatusCode: 400
    Amount:
      title: Amount Details
      required:
        - amount
        - currency
      type: object
      properties:
        amount:
          title: Amount
          type: number
          description: __Mandatory__. The monetary value
          example: 10
        currency:
          title: Currency
          type: string
          description: >-
            __Mandatory__. The [ISO 4217](https://www.xe.com/iso4217.php)
            currency code
          example: GBP
      description: __Mandatory__. Monetary Amount.
    ResponseMeta:
      type: object
      properties:
        tracingId:
          type: string
    VrpFundsConfirmationResponse:
      required:
        - paymentAmount
        - fundsAvailable
      type: object
      properties:
        id:
          type: string
        reference:
          type: string
          description: >-
            The payment reference or description. Limited to a maximum of 18
            characters long.
          example: Own Account Sweeping
        paymentAmount:
          $ref: '#/components/schemas/Amount'
        fundsAvailable:
          $ref: '#/components/schemas/VrpFundsAvailable'
    ResponseForwardedData:
      type: object
      properties:
        headers:
          type: object
          additionalProperties:
            type: string
        url:
          type: string
    RawResponse:
      deprecated: true
      type: object
      description: >-
        [DEPRECATED] Interaction (raw request and response) that occurred with
        the `Institution` in order to fulfil a request.
      properties:
        request:
          $ref: '#/components/schemas/RawRequest'
        duration:
          type: string
          format: iso8601
        headers:
          type: object
          additionalProperties:
            type: string
        resultCode:
          type: integer
          format: int32
        result:
          type: object
    ErrorDetails:
      required:
        - tracingId
        - code
        - status
      type: object
      properties:
        tracingId:
          type: string
          description: >-
            Unique identifier of the request, used by Yapily for support
            purposes
        code:
          type: integer
          format: int32
          description: Numeric HTTP status code associated with the error
        status:
          type: string
          description: Textual description of the HTTP status
        supportUrl:
          type: string
          description: Link to where further information regarding the error can be found
        source:
          type: string
          description: >-
            Source of the error. This may be YAPILY, the INSTITUTION, or the
            USER
        issues:
          type: array
          description: List of issues relating to the error
          items:
            $ref: '#/components/schemas/ErrorIssue'
    VrpFundsAvailable:
      required:
        - fundsAvailable
        - fundsAvailableAt
      type: object
      properties:
        fundsAvailable:
          type: boolean
          description: __Mandatory__. The flag indicating whether the funds are available.
        fundsAvailableAt:
          type: string
          format: date-time
          description: __Mandatory__. The datetime when the funds were checked.
    RawRequest:
      type: object
      properties:
        method:
          type: string
        url:
          type: string
        requestInstant:
          type: string
          format: date-time
        headers:
          type: object
          additionalProperties:
            type: string
        body:
          type: object
        bodyParameters:
          type: object
          additionalProperties:
            type: string
        startTime:
          type: string
          format: date-time
        startedAt:
          type: string
          format: date-time
          deprecated: true
    ErrorIssue:
      required:
        - type
        - code
      type: object
      description: >-
        Detailed information regarding the issue that was experienced during
        processing of the request
      properties:
        type:
          type: string
          description: Category of the issue
        code:
          type: string
          description: Code that uniquely identifies the type of issue
        parameter:
          type: string
          description: >-
            Identifies the parameter / property within the request (headers,
            query parameters or body) that the issue relates to. For headers and
            query parameters, it refers to the parameter name. For the body, it
            refers to the JSONPath of the property
        message:
          type: string
          description: Human readable description of the issue that was experienced
        institutionError:
          $ref: '#/components/schemas/InstitutionError'
    InstitutionError:
      type: object
      description: >-
        Raw error details provided by the `Institution`, when it was the error
        source.
      properties:
        errorMessage:
          type: string
          description: Textual description of the `Institution` error.
        httpStatusCode:
          type: integer
          description: Numeric HTTP status code associated with the `Institution` error.
          format: int32
  securitySchemes:
    basicAuth:
      description: >-
        Use HTTP Basic Authentication with your Application ID as username and
        Application Secret as password. Manage credentials in the [Yapily
        Console](https://console.yapily.com/). See
        [Authentication](/api-reference/authentication) for details.
      scheme: basic
      type: http

````